/**
 * Copyright 2009, AIAN
 * This code may be freely used in any application.
 *
 * ORIGINAL IMPLEMENTATION NOTICE:
 * This hashing class is based on the NIST's Secure Hash Algorithm (FIPS 180).
 * And the original code written in C is implemented by James J. Gillogly as a
 * free-usable code. You can refer to the original at the URL below.
 *
 * http://www.ussrback.com/crypto/source/hash/SHS/t/sha.c
 *
 * Original Copyright 1993, Dr. James J. Gillogly
 */
#ifndef HASH_H__INCLUDED
#define HAHS_H__INCLUDED

#include <string>

class Hash {
public:
    Hash();
    virtual ~Hash();
private:
    Hash(const Hash& other);
    Hash& operator=(const Hash& rhs);
protected:
    typedef unsigned long U32;
protected:
    union LongByte {
        U32 W[80];
        char B[320];
    };
protected:
    inline U32 f0(U32 x, U32 y, U32 z);
    inline U32 f1(U32 x, U32 y, U32 z);
    inline U32 f2(U32 x, U32 y, U32 z);
    inline U32 f3(U32 x, U32 y, U32 z);
    inline U32 S(U32 n, U32 x);
public:
    /** 
     *
     */
    std::string get(const std::string& mem);
protected:
    void doHash(const char* mem, U32 length);
protected:
    static const U32 K0;
    static const U32 K1;
    static const U32 K2;
    static const U32 K3;
protected:
    U32 hbuf_[5];
};

#endif  // HAHS_H__INCLUDED
